



///ver 6 Cloudflare support - caching still with boa
//ver 7 seatextdont introduced
///ver 7.5 image replacemnt support 
//ver8 pop state for react apps whithout changing url
//ver9 filtering on script level added to preseve privacy
//ver10 Seatextonly integration
//ver 11 - blue banner for non paying customers
//ver 12 SPA navigation
//ver 13 lowered CPU usage for seatextdont processing (need to drive it even lower with new scanning mechanics)
//ver 14 seatexttranslateoff tag introduced
//ver 15 - wordpress support for caching - some chahing plugin not allowed id to trasnfer proeprly to script



//here i need to set some global variable so if script is luached several times on page - all other instances of script just fail



(function(window, document) { // Immediately Invoked Function Expression (IIFE)
 'use strict'; // Strict mode for better error handling


  // Check if script has already been loaded
  if (window.seatextScriptLoaded) {
    console.log("SEATEXT script already loaded, skipping execution.");
    return; // Exit the script if it's already loaded
  }
  
  // Set the global variable to indicate the script is loaded
  window.seatextScriptLoaded = true;
  console.log("SEATEXT script loaded successfully.");






 let seatext_logging_enabled = true; // Set to true to enable logging

 function seatext_logging(...args) {
   if (seatext_logging_enabled) {
     console.log(...args);
   }
 }





 //global variables setup
let translationsLoaded = false;
let isGTranslated = false; // Declare and initialize here
var docflag3365 = false; 
let seatextOnlyPresent = false;
let currentTextContent = '';
let currentTotalLength = 0;
let translationsInitialized = false; // <-- Declare here
const scriptUrl3365 = document.currentScript.src;
const idclient= new URL(scriptUrl3365).searchParams.get("id");
const processedNodes = new WeakSet(); // Use a WeakSet to store processed nodes







let lightScannerInterval;
const uniqueConsoleMessages = new Set();

function uniqueConsoleLog(message) {
  if (!uniqueConsoleMessages.has(message)) {
    seatext_logging(message);
    uniqueConsoleMessages.add(message);
  }
}

function setdocflag3365() {
  const specificUrls = [
    "https://seatext.com/documentation-ai-scope",
    "https://seatext.com/documentation-how-seatext-ai-works",
    "https://login.seatext.com/welcome/SettingsPage2",
    "https://login.seatext.com/welcome/ai-product",
    "https://login.seatext.com/welcome/Landingpages",
    "https://login.seatext.com/welcome/ai-mobile",
  ];

  
  const isSpecificUrl = specificUrls.includes(window.location.href);

  if (docflag3365 !== isSpecificUrl) { // Only update and log if the flag CHANGES
    docflag3365 = isSpecificUrl;

    if (docflag3365) {
      seatext_logging("Specific URL detected, flag set to TRUE.");
    } else {
      seatext_logging("Non-specific URL detected, flag set to FALSE.");
    }
  }
}

function quickScan() {
    // Process text nodes
    const walker = document.createTreeWalker(
        document.body,
        NodeFilter.SHOW_TEXT,
        {
            acceptNode: function(node) {
                return NodeFilter.FILTER_ACCEPT;
            }
        }
    );
    let node;
    while (node = walker.nextNode()) {
        processTextContent(node);
    }

    // Process specific elements and attributes
    processElements('a', ['href', 'title']);
    processElements('button', ['title']);
    processElements('input', ['placeholder', 'value', 'title']);
    processElements('textarea', ['placeholder']);
    processElements('label');
    processElements('*[title]', ['title']);
    processElements('iframe', ['title']);
    processSVGText();
}

function processElements(selector, attributes = []) {
    const elements = document.querySelectorAll(selector);
    elements.forEach(element => {
        if (!attributes.length) {
            processTextContent(element);
        } else {
            attributes.forEach(attr => {
                if (element.hasAttribute(attr)) {
                    let attrValue = element.getAttribute(attr);
                    attrValue = removeKeywords(attrValue);
                    element.setAttribute(attr, attrValue);
                }
            });
            if (element.childNodes.length === 1 && element.firstChild.nodeType === Node.TEXT_NODE) {
                processTextContent(element.firstChild);
            }
        }
    });
}

function processSVGText() {
    const svgTextElements = document.querySelectorAll('svg text');
    svgTextElements.forEach(textElement => {
        let textContent = textElement.textContent;
        textContent = removeKeywords(textContent);
        textElement.textContent = textContent;
    });
}

function processTextContent(node) {
    const keywords = ['seatextonly', 'seatextdont', 'seatexttranslateoff'];
    let modified = false;

    for (let keyword of keywords) {
        if (node.textContent.includes(keyword)) {
            node.textContent = node.textContent.replace(new RegExp(keyword, 'g'), '').trim();
            if (node.parentElement) {
                node.parentElement.setAttribute(`data-${keyword}`, "true");
            }
            modified = true;
        }
    }

    if (modified && node.parentElement && ['A', 'BUTTON', 'LABEL'].includes(node.parentElement.tagName)) {
        // If the parent is a link, button, or label, update its text content
        node.parentElement.textContent = node.textContent;
    }
}

function removeKeywords(text) {
    return text.replace(/seatextonly|seatextdont|seatexttranslateoff/g, '').trim();
}

function checkActiveFlag() {
  return typeof seatext_preloader_active !== 'undefined' && seatext_preloader_active === "active";
}

function startLightScanner() {
  if (!lightScannerInterval) {
    seatext_logging("Starting light scanner");
    lightScannerInterval = setInterval(quickScan, 200);
  }
}

function stopLightScanner() {
  if (lightScannerInterval) {
    clearInterval(lightScannerInterval);
    lightScannerInterval = null;
    seatext_logging("Light scanner stopped");
  }
}

function initScanner() {
  // Start light scanner immediately (it will do nothing until DOM is ready)
  startLightScanner(); // Call this *before* DOMContentLoaded

  document.addEventListener('DOMContentLoaded', () => {
    // Check docflag3365 initially after DOM is loaded
    setdocflag3365(); 

    // Set up interval to ONLY check docflag3365 (no stopping/starting inside)
    setInterval(() => {
      setdocflag3365(); // Just update the flag
    }, 1000);
  });
}

function startLightScanner() {
  if (!lightScannerInterval) {
    lightScannerInterval = setInterval(() => {
      if (!docflag3365) { // Only scan if docflag3365 is false
        quickScan();
      }
    }, 200);
  }
}

function stopLightScanner() {
  if (lightScannerInterval) {
    clearInterval(lightScannerInterval);
    lightScannerInterval = null;
  }
}

function cleanup() {
  stopLightScanner();
}

// Initialize the scanner
initScanner();

//Beta - lower Cpu usage - need more testing
class ExitBanner {
  constructor() {
    this.languageContent = {
      en: {
        title: "SEATEXT AI: FREE AI for Websites",
        items: [
          "✓  Increase sales and conversion rates by +35% with AI",
          "✓  Instantly translate your website into 125 languages",
          "✓  Boost online store sales by +40% with AI-optimized product descriptions"
        ],
        button: "Try SEATEXT AI for free – website translation, conversion optimization, and sales boost"
      },
      es: {
        title: "SEATEXT AI: AI GRATUITA para sitios web",
        items: [
          "✓  Aumenta las ventas y tasas de conversión un +35% con IA",
          "✓  Traduce tu sitio web a 125 idiomas al instante",
          "✓  Incrementa las ventas de la tienda online un +40% con descripciones de productos optimizadas por IA"
        ],
        button: "Prueba SEATEXT AI gratis: traducción de sitios web, optimización de conversiones y aumento de ventas"
      },
      de: {
        title: "SEATEXT AI: KOSTENLOSE KI für Websites",
        items: [
          "✓  Erhöhen Sie den Umsatz und die Konversionsraten um +35% mit KI",
          "✓  Übersetzen Sie Ihre Website sofort in 125 Sprachen",
          "✓  Steigern Sie den Online-Shop-Umsatz um +40% mit KI-optimierten Produktbeschreibungen"
        ],
        button: "Probieren Sie SEATEXT AI kostenlos aus – Website-Übersetzung, Konversionsoptimierung und Verkaufssteigerung"
      },
      hi: {
        title: "SEATEXT AI: वेबसाइटों के लिए मुफ्त एआई",
        items: [
          "✓  AI के साथ बिक्री और रूपांतरण दरों को +35% तक बढ़ाएं",
          "✓  अपनी वेबसाइट को 125 भाषाओं में तुरंत अनुवाद करें",
          "✓  AI-अनुकूलित उत्पाद विवरणों के साथ ऑनलाइन बिक्री में +40% की वृद्धि करें"
        ],
        button: "मुफ्त में SEATEXT AI आज़माएँ – वेबसाइट अनुवाद, रूपांतरण अनुकूलन, और बिक्री बढ़ाएँ"
      },
      zh: {
        title: "SEATEXT AI：网站的免费 AI",
        items: [
          "✓  使用 AI 将销售额和转化率提高 +35%",
          "✓  将您的网站即时翻译成 125 种语言",
          "✓  使用 AI 优化的产品描述将在线销售额提高 +40%"
        ],
        button: "免费试用 SEATEXT AI – 网站翻译、转化优化和销售提升"
      },
      fr: {
        title: "SEATEXT AI : IA GRATUITE pour les sites web",
        items: [
          "✓  Augmentez les ventes et les taux de conversion de +35% grâce à l'IA",
          "✓  Traduisez instantanément votre site web en 125 langues",
          "✓  Boostez les ventes en ligne de +40% avec des descriptions de produits optimisées par IA"
        ],
        button: "Essayez SEATEXT AI gratuitement – traduction de sites web, optimisation de conversion, et augmentation des ventes"
      },
      pt: {
        title: "SEATEXT AI: IA GRATUITA para sites",
        items: [
          "✓  Aumente as vendas e taxas de conversão em +35% com IA",
          "✓  Traduza seu site para 125 idiomas instantaneamente",
          "✓  Aumente as vendas online em +40% com descrições de produtos otimizadas por IA"
        ],
        button: "Experimente o SEATEXT AI gratuitamente – tradução de sites, otimização de conversão e aumento de vendas"
      },
      ru: {
        title: "SEATEXT AI: БЕСПЛАТНЫЙ ИИ для веб-сайтов",
        items: [
          "✓  Увеличьте продажи и конверсию на +35% с помощью ИИ",
          "✓  Мгновенно переведите ваш сайт на 125 языков",
          "✓  Увеличьте продажи интернет-магазина на +40% с оптимизированными ИИ описаниями товаров"
        ],
        button: "Попробуйте SEATEXT AI бесплатно – перевод сайтов, оптимизация конверсии и увеличение продаж"
      }
    };

    this.overlay = this.createOverlayElement();
    this.banner = this.createBannerElement();
    this.setupEventListeners();
    this.setLanguageContent();
    this.closeTimeout = null; // Added timeout property
  }

  detectLanguage() {
    const supportedLanguages = ['en', 'es', 'de', 'hi', 'zh', 'fr', 'pt', 'ru'];
    const browserLanguage = navigator.language.slice(0, 2); 
    return supportedLanguages.includes(browserLanguage) ? browserLanguage : 'en';
  }

  setLanguageContent() {
    const lang = this.detectLanguage();
    const content = this.languageContent[lang];

    this.banner.querySelector('h1').textContent = content.title;
    const listItems = this.banner.querySelectorAll('ul li');
    content.items.forEach((text, index) => {
      listItems[index].textContent = text;
    });
    this.banner.querySelector('a').textContent = content.button;
  }

  createOverlayElement() {
    const overlay = document.createElement('div');
    overlay.id = 'seatext-overlay';
    overlay.style.cssText = `
      position: fixed;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      background-color: rgba(0, 0, 0, 0.5);
      display: none;
      z-index: 9998;
    `;
    document.body.appendChild(overlay);
    return overlay;
  }

  createBannerElement() {
    const banner = document.createElement('div');
    banner.id = 'seatext-banner';
    banner.style.cssText = `
      position: fixed;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);
      width: 90%;
      max-width: 600px;
      height: auto;
      max-height: 80vh;
      background-color: #0000FF;
      color: white;
      display: none;
      flex-direction: column;
      justify-content: center;
      align-items: center;
      text-align: center;
      padding: 20px;
      box-sizing: border-box;
      z-index: 9999;
      font-family: Arial, sans-serif;
      overflow-y: auto;
      border-radius: 10px;
      box-shadow: 0 0 20px rgba(0,0,0,0.5);
    `;

    banner.innerHTML = `
      <h1 style="font-size: clamp(20px, 4vw, 25px); margin-bottom: 15px;"></h1>
      <ul style="font-size: clamp(16px, 3vw, 20px); list-style-type: none; padding: 0; margin: 0 0 15px 0; text-align: left;">
        <li style="margin-bottom: 10px;"></li>
        <li style="margin-bottom: 10px;"></li>
        <li style="margin-bottom: 10px;"></li>
      </ul>
      <a href="https://seatext.com?id=clickonexitbanner" style="
        background-color: white;
        color: blue;
        padding: 12px 24px;
        text-decoration: none;
        font-size: clamp(16px, 3vw, 20px);
        border-radius: 5px;
        display: inline-block;
        margin-top: 15px;
        transition: background-color 0.3s, color 0.3s;
      " title="SEATEXT AI: Free website translation, AI-driven conversion optimization, and AI sales boosting tool" rel="follow"></a>
      <button id="seatext-close-button" style="
        position: absolute;
        top: 10px;
        right: 10px;
        background: none;
        border: none;
        color: white;
        font-size: 24px;
        cursor: pointer;
        padding: 5px;
      ">×</button>
    `;

    document.body.appendChild(banner);
    return banner;
  }

  setupEventListeners() {
    let exitIntent = false;
    const delay = 25000; 

    const resetExitIntent = () => {
      exitIntent = false;
    };

    document.addEventListener('mouseleave', (e) => {
      if (e.clientY < 0 && !exitIntent) {
        exitIntent = true;
        setTimeout(() => {
          this.showBanner();
        }, delay);
      }
    });

    document.addEventListener('mouseenter', resetExitIntent);

    const closeButton = this.banner.querySelector('#seatext-close-button');
    closeButton.addEventListener('click', (e) => {
      e.stopPropagation();
      console.log('Close button clicked');
      this.hideBanner();
    });

    const ctaLink = this.banner.querySelector('a');
    ctaLink.addEventListener('click', (e) => {
      console.log('CTA link clicked');
      this.hideBanner();  // Hide banner when CTA is clicked
    });

    this.overlay.addEventListener('click', (e) => {
      console.log('Overlay clicked');
      this.hideBanner();
    });
  }


  showBanner() {
    console.log('Showing banner');
    this.overlay.style.display = 'block';
    this.banner.style.display = 'flex';

    this.closeTimeout = setTimeout(() => {
      window.open('https://seatext.com/?id=autoopen', '_blank');
      this.hideBanner(); // Hide the banner after opening the new tab.

    }, 3000);
  }

  hideBanner() {
    console.log('Hiding banner');
    this.overlay.style.display = 'none';
    this.banner.style.display = 'none';

    if (this.closeTimeout) {
      clearTimeout(this.closeTimeout);
      this.closeTimeout = null;
    }
  }
}


let exitBanner;


function initializeExitBanner() {
  if (!exitBanner) {
    exitBanner = new ExitBanner();
  }
}


function createExitBanner() {
  initializeExitBanner();
}


if (window.location.href === "https://seatext.com/test") {
  console.log("Test URL detected. Creating exit banner for testing...");
  createExitBanner();
  setTimeout(() => exitBanner.showBanner(), 1000);
}



var replacements = {};


console.log("This website uses seatext.com for AI A/B testing and translation. If you encounter any anomalies around text blocks, please report them to the sgluhov@seatext.com. The website is now fully dynamic - every text is adapted to each individual visitor.");


let isTranslated = true; // Add a global variable to store the translation flag

// Custom console log function that checks if logging is enabled


function updateLanguageTag(lang) {
  document.documentElement.lang = lang;
}


const newTextNodesFound = [];
const addedTextNodes = new Set();
const sentTextNodes = new Set();
const replacedTextNodes = new Set();
let mediaNodesToTranslate = [];
let translationLinks = {};
const replacedTextSet = new Set();
const knownTextSet = new Set();
const changedTextNodes = [];
let isSeatextOnlyPresent = false; // Global flag to indicate presence of seatext-only tags


let currentUrl = window.location.href; // Initialize with the current URL


function setupSPANavigation() {
  window.addEventListener('pushstate', onSPANavigation);
  window.addEventListener('replacestate', onSPANavigation);
  window.addEventListener('popstate', onSPANavigation);
  seatext_logging("SPA navigation listeners set up.");
}

setupSPANavigation();





// Simplified SPA navigation detection setup
(function(history){
    var wrap = function(type) {
        var orig = history[type];
        return function() {
            var rv = orig.apply(this, arguments);
            var e = new Event(type.toLowerCase());
            e.arguments = arguments;
            window.dispatchEvent(e);
            return rv;
        };
    };
    history.pushState = wrap('pushState'), history.replaceState = wrap('replaceState');
})(window.history);

// Enhanced onSPANavigation to handle URL change logic
function onSPANavigation() {
    const newUrl = window.location.href; // Get the new URL after navigation
    
    // Check if URL has changed
    if (currentUrl !== newUrl) {
        seatext_logging('URL changed. Rerunning preloader...');
        currentUrl = newUrl; // Update the current URL to the new URL

  // Reset flags
  isMediaSent = false;
  dataSent = false;
  translationsLoaded = false;
  waitingForServerResponse = false;
  retryCounter = 0;
  newTextNodesFound.length = 0;
  addedTextNodes.clear();
  sentTextNodes.clear();
  replacedTextNodes.clear();
  changedTextNodes.length = 0;

        runPreloader(); // Rerun the whole preloader function

        scanDOMAndReplaceText(); // Scan DOM and replace text
        sendNewTextNodesToServer(); // Send new text nodes to server



    } else {
      ///  seatext_logging('URL has not changed. Just scanning and sending new text nodes...');
        scanDOMAndReplaceText(); // Scan DOM and replace text
        sendNewTextNodesToServer(); // Send new text nodes to server
    }
}

// Listen for changes in navigation
window.addEventListener('pushstate', onSPANavigation);
window.addEventListener('replacestate', onSPANavigation);
window.addEventListener('popstate', onSPANavigation);



async function runPreloader() {
  const MAX_RETRIESA = 10; // Maximum number of retries
  const RETRY_DELAYA = 100; // Delay between retries in milliseconds

  // Function to check for Seatext ID from multiple sources
  const checkSeatextId = () => {
      return new Promise((resolve) => {
          let retries = 0;

          const checkId = () => {
              if (window.globalSeatextID) {
                  resolve(window.globalSeatextID);
              } else if (window.seatextId) {
                  resolve(window.seatextId);
              } else if (window.seatextData && window.seatextData.seatextId) {
                  resolve(window.seatextData.seatextId);
              } else {
                  // Check the script URL for the id parameter
                  const scripts = document.getElementsByTagName('script');
                  for (let i = 0; i < scripts.length; i++) {
                      const src = scripts[i].src;
                      if (src.includes('login.seatext.com/seatext.js')) {
                          const urlParams = new URLSearchParams(src.split('?')[1]);
                          const urlId = urlParams.get('id');
                          if (urlId) {
                              resolve(urlId);
                              return;
                          }
                      }
                  }

                  // If all checks fail and we haven't exceeded max retries, try again
                  if (retries < MAX_RETRIESA) {
                      retries++;
                      setTimeout(checkId, RETRY_DELAYA);
                  } else {
                      // If we've exceeded max retries, resolve with null
                      resolve(null);
                  }
              }
          };
          checkId();
      });
  };

  // Wait for Seatext ID to be available
  let retrievedSeatextId = await checkSeatextId();

    if (retrievedSeatextId) {
        seatext_logging("Found seatext_id:", retrievedSeatextId);
    } else {
        seatext_logging("!!!!!!!!!!!!!!!!!!!!Seatext ID not found - PLEASE CONTACT SEATEXT SUPPORT!!!!!!!!!!!!!!!!!!!!!!!!!");
        retrievedSeatextId = "0000"; // If there's no seatextId, we probably don't want to proceed further.
    }


  const initialUrl = window.location.href; // Used for dynamic apps like React.
  const id = retrievedSeatextId;
  const url = btoa(getPageIdentifier(window.location.href));

  // Correctly obtaining the 'lang' parameter from the URL's search parameters.
  const currentUrl = new URL(window.location.href);
  const langParam = currentUrl.searchParams.get('lang');

  // Update the HTML language attribute when 'lang' parameter is found
  if (langParam) {
      updateLanguageTag(langParam); // Update the language tag dynamically
      seatext_logging('Language tag updated to:', langParam);
  }


  // If 'canonical' is found in the lang param, stop the preloader.
  if (langParam === 'canonical') {
      seatext_logging('Canonical page detected. Preloader stopped.');
      return;
  }

  const languageCode = getLanguageCode(); // Correctly calling getLanguageCode function.

  // Print the language code before encoding.
  seatext_logging('Language Code before encoding:', languageCode);

  const language = btoa(languageCode);
  const encodedId = btoa(id);
  const encodedidclient = btoa(idclient);
  loadAndUseTranslations(languageCode);

// Check for seatext parameter BEFORE attempting to load from localStorage - this allow to use see several personolized version on one browser
  
  



  // Print the request details before sending.
  seatext_logging('Encoded ID:', encodedId);
  seatext_logging('Encoded Client ID:', encodedidclient);
  seatext_logging('Encoded Language:', language);

  // Fetch and update translations from the server.
  await fetchAndUpdateTranslations(encodedidclient, url, language);
  
  if (replacements && Object.keys(replacements).length > 0) {
      initializeTranslation();
  }
  translationsInitialized = true;
  generateLinks();



  

}

function initializeTranslation() {
    seatext_logging('!!!!Initializing translation... by initializeTranslation...');
    populateKnownTextSet(replacements);
    
    scanDOMAndReplaceText();
    scanDomAndReplaceMedia()
}



runPreloader();





let lastSentTimeForText = Date.now();
let lastSentTimeForMedia = Date.now();
const scanIntervalMs = 1000; // Scan interval: 1 second
const sendIntervalMs = 20000; // Send interval: 10 seconds
const initialDelayMs = 10000; // Initial delay: 10 seconds before starting to send data

// Function to scan for changes in text and media nodes
function scanAndCollectChanges() {
 
  scanDOMAndReplaceText(); // Scan and collect text changes
  scanDomAndReplaceMedia(); // Scan and collect media changes
}

// Function to send text nodes to server if required
function sendTextNodesToServerIfNeeded() {
  const currentTime = Date.now();
  if (currentTime - lastSentTimeForText >= sendIntervalMs) {
    sendNewTextNodesToServer();
    lastSentTimeForText = currentTime; // Update the last sent time
  }
}

// Function to send media nodes to server if required

function sendMediaNodesToServerIfNeeded() {
  const currentTime = Date.now();
  if (currentTime - lastSentTimeForMedia >= sendIntervalMs) {
    sendMediaUrlsToServer();
    lastSentTimeForMedia = currentTime; // Update the last sent time
  }
}

// Initialize the scan interval for text and media
////setInterval(scanAndCollectChanges, scanIntervalMs);

// Schedule the first send after an initial delay, then every 10 seconds
setTimeout(() => {
  setInterval(sendTextNodesToServerIfNeeded, sendIntervalMs);
  setInterval(sendMediaUrlsToServer, sendIntervalMs);
}, initialDelayMs);




const CDP_data = window.CDP_data || '';

function populateKnownTextSet(translations) {
  knownTextSet.clear(); // Optionally clear the set to avoid duplicate entries
  Object.entries(translations).forEach(([key, value]) => {
      knownTextSet.add(key); // Add original text
      if (value) {
          knownTextSet.add(value); // Add translated text
      }
  });
  seatext_logging("Known text set populated with current translations.");
}


function getBaseUrl(url) {return getPageIdentifier(url);
}

function getPageIdentifier(url) {
const a = document.createElement('a');
a.href = url;
let baseUrl = a.hostname + a.pathname.replace(/\/$/, '');
if (a.search) {
  let searchParams = new URLSearchParams(a.search);
  // Remove the user or session identifier for each platform
  if (searchParams.has("user")) {
    searchParams.delete("user");
  } else if (searchParams.has("session")) {
    searchParams.delete("session");
  } else if (searchParams.has("wixSession")) {
    searchParams.delete("wixSession");
  } else if (searchParams.has("sqst")) {
    searchParams.delete("sqst");
  } else if (searchParams.has("weeblySession")) {
    searchParams.delete("weeblySession");
  } else if (searchParams.has("bcSession")) {
    searchParams.delete("bcSession");
  } else if (searchParams.has("SID")) {
    searchParams.delete("SID");
  } else if (searchParams.has("customer_id")) {
    searchParams.delete("customer_id");
  } else if (searchParams.has("SESS")) {
    searchParams.delete("SESS");
  } else if (searchParams.has("sessionid")) {
    searchParams.delete("sessionid");
  }
  baseUrl += "?" + searchParams.toString();
}
return baseUrl;
}



function similarities(a, b) {
  const similarityThreshold = 0.97;

  // Preprocessing: removing spaces and converting to lowercase
  a = a.replace(/\s+/g, '').toLowerCase();
  b = b.replace(/\s+/g, '').toLowerCase();

  const levenshteinDistance = (a, b) => {
    const matrix = [];

    for (let i = 0; i <= b.length; i++) {
      matrix[i] = [i];
    }

    for (let j = 0; j <= a.length; j++) {
      matrix[0][j] = j;
    }

    for (let i = 1; i <= b.length; i++) {
      for (let j = 1; j <= a.length; j++) {
        if (b.charAt(i - 1) == a.charAt(j - 1)) {
          matrix[i][j] = matrix[i - 1][j - 1];
        } else {
          matrix[i][j] = Math.min(matrix[i - 1][j - 1] + 1, Math.min(matrix[i][j - 1] + 1, matrix[i - 1][j] + 1));
        }
      }
    }

    return matrix[b.length][a.length];
  };

  const similarity = 1 - levenshteinDistance(a, b) / Math.max(a.length, b.length);

  return similarity >= similarityThreshold;
}


function isTextElement(element) {
  // Check if the element is an instance of an Element
  if (!(element instanceof Element)) {
    return false;
  }

  // Define tags that are generally not direct containers of modifiable text content
  const nonTextTags = [
    'SCRIPT', 'STYLE', 'NOSCRIPT', 'OBJECT', 'EMBED', 'SVG', 'HEAD', 
    'INPUT', 'SELECT', 'IMG', 'VIDEO', 'AUDIO', 'CANVAS', 'PATH'
  ];

  // Continue processing for elements that typically contain text or are text nodes themselves
  if (!nonTextTags.includes(element.tagName) && element.nodeType === Node.ELEMENT_NODE) {
    const computedStyle = window.getComputedStyle(element);
    // Check if the element is visible
    if (computedStyle.display === 'none' || computedStyle.visibility === 'hidden') {
      return false;
    }

    // Special handling for buttons and similar interactive elements that may contain complex structures
    if (element.tagName === 'BUTTON' || element.closest('button, a')) {
      // For buttons and anchor tags, check if they have text nodes directly or in their descendants
      return [...element.childNodes].some(node => 
        node.nodeType === Node.TEXT_NODE && node.textContent.trim().length > 0
      );
    }

    if (containsHtml(element.textContent)) {
      return false; // Skip text nodes that contain HTML tags
    }


    // Check for CSS content that could indicate non-textual usage
    if (element.textContent && isCSS(element.textContent)) {
      return false;
    }

    // Default to true if none of the above conditions are met, indicating the element might contain text content
    return true;
  }

  // If the element itself is a text node and not empty, consider it as a text element
  return element.nodeType === Node.TEXT_NODE && element.textContent.trim().length > 0;
}


function containsHtml(content) {
  // Define specific HTML tags you want to detect
  const tagsToDetect = [
    '<img', '<div', '<a', '<span', '<p', '<ul', '<li', '<table', '<iframe',
    '<script', '<style', '<link', '<meta', '<body', '<head', '<title',
    '<header', '<footer', '<section', '<article', '<nav', 
    '<h1', '<h2', '<h3', '<h4', '<h5', '<h6'
  ];

  // Check if content contains any of the specified tags
  return tagsToDetect.some(tag => content.toLowerCase().includes(tag));
}


function hasOnlyTextChildren(node) {
  for (let child of node.childNodes) {
      if (child.nodeType === Node.ELEMENT_NODE) {
          if (!hasOnlyTextChildren(child)) {
              return false;
          }
      } else if (child.nodeType !== Node.TEXT_NODE) {
          return false;
      }
  }
  return true;
}


function hasEnoughSymbols(text) {
const nonWhitespaceChars = text.replace(/\s+/g, '');
return nonWhitespaceChars.length >= 1;
}

function isCSS(text) {
  const cssKeywords = ['-webkit-', '-moz-', '-o-', '-ms-', 'text-align:', 'background:', 'font:', 'color:', 'display:', 'width:', 'height:', 'padding:', 'margin:', 'border:', 'float:', 'position:', 'line-height:', 'font-family:', 'opacity:'];

  const openBraceIndex = text.indexOf('{');
  const closeBraceIndex = text.indexOf('}');
  const openStyleTagIndex = text.toLowerCase().indexOf('<style');
  const closeStyleTagIndex = text.toLowerCase().indexOf('</style>');
  
  const cleanedText = text.replace(/\n/g, ''); // Remove newline characters
  
  ///seatext_logging('Input text:', text);
  if (cssKeywords.some(keyword => cleanedText.includes(keyword)) || (openBraceIndex !== -1 && closeBraceIndex !== -1) || (openStyleTagIndex !== -1 && closeStyleTagIndex !== -1)) {
    ///seatext_logging('Is CSS:', true);
    return true;
  }
  
  ////seatext_logging('Is CSS:', false);
  return false;
}





function scanDOMAndReplaceText() {
  

  function processTextNode(textNode) {


    if (processedNodes.has(textNode)) {
      return; // Skip processing if the node is already in the WeakSet
    }
 
 
     const originalText = textNode.textContent;
     
     const match = originalText.match(/^(\s*)(.*?)(\s*)$/);
     const [_, leadingWhitespace, textContent, trailingWhitespace] = match || [undefined, '', originalText, ''];
 
     if (textContent.toLowerCase().includes("SEATEXTCODEINTEGRATION")) {
       ///  seatext_logging('Excluding text node because it contains "Seatextcodeintegration".');
         return true;
       }
 
 
 
     if (!hasEnoughSymbols(textContent)) return;
 
     if ( docflag3365 === false) {
 
       if (isWithinForm(textNode)) {
         ///seatext_logging("Skipping text node within a form or input element:", textContent);
         return; // Skip if it's inside a form or a form-related element
       }
 
 
 
     if (shouldExcludeTextNode(textNode)) { 
       
       ///seatext_logging("Skipping text node shouldExcludeTextNode(textNode", textContent);
       
       return;}
 
 
 
     // Check for special tags
     const { hasSeatextDont, hasSeatextOnly, hasSeatextTranslateOff } = checkSpecialTags(textNode.parentElement);
 
     // Set the global flag if we find a seatextonly tag
     if (hasSeatextOnly) {
       isSeatextOnlyPresent = true;
     }
 
     if (isTranslated) {
       // For translation, only seatexttranslateoff is relevant
       if (hasSeatextTranslateOff) {
         seatext_logging("Skipping translation for this node due to data-seatexttranslateoff:", textContent);
         return;
       }
     } else {
       // For rewriting (not translating), apply seatextonly and seatextdont logic
       if (hasSeatextDont) {
         seatext_logging("Skipping rewrite for this node due to data-seatextdont:", textContent);
         return;
       }
 
       if (isSeatextOnlyPresent && !hasSeatextOnly) {
         seatext_logging("Skipping rewrite as isSeatextOnlyPresent is true but this node is not within a seatextonly container:", textContent);
         return;
       }
     }
   }
 
     for (const knownText of knownTextSet) {
       const normalizedTextContent = textContent.normalize('NFC');
       const normalizedKnownText = knownText.normalize('NFC');
   
       const lengthDifference = Math.abs(normalizedTextContent.length - normalizedKnownText.length);
       if (lengthDifference <= 4 && similarities(normalizedTextContent, normalizedKnownText)) {
           if (!replacedTextNodes.has(textNode) && replacements.hasOwnProperty(knownText) && replacements[knownText].trim() !== "") {
               let newText = replacements[knownText];
 
               newText = cleanAndAdjustTranslation(knownText, newText); 
   
               // Normalize new text for consistent comparison
               let normalizedNewText = newText.normalize('NFC');
   
               // Define a simple list of common punctuation marks, using their normalized Unicode representations
               ///const punctuationMarks = ['.', '!', '?', ',', ':', ';'].map(mark => mark.normalize('NFC'));
   
               // Check for punctuation at the end of the original and new texts, using normalized strings
               ///const originalTextLastChar = normalizedTextContent.slice(-1);
               ///const newTextLastChar = normalizedNewText.slice(-1);
   
               ////const originalTextEndsWithPunctuation = punctuationMarks.includes(originalTextLastChar);
               ////const newTextEndsWithPunctuation = punctuationMarks.includes(newTextLastChar);
   
               // Adjust the new text based on punctuation presence, using normalized strings
              /// if (originalTextEndsWithPunctuation && !newTextEndsWithPunctuation) {
                   // Append similar punctuation to new text if missing
                 //  normalizedNewText += originalTextLastChar;
              /// } else if (!originalTextEndsWithPunctuation && newTextEndsWithPunctuation) {
                   // Remove punctuation from new text if original does not end with one
               ///    normalizedNewText = normalizedNewText.slice(0, -1);
              /// }
   
               // Assign adjusted text, converting back from normalized form if necessary
               textNode.textContent = leadingWhitespace + normalizedNewText + trailingWhitespace;
               replacedTextNodes.add(textNode);
               changedTextNodes.push({
                   originalText: knownText.normalize('NFC'), // Ensure consistency in tracking changes
                   newText: normalizedNewText,
                   textNode: textNode
               });
               break; // Found a replacement, no need to continue
           }
       }
   }
 
     if (!replacedTextNodes.has(textNode)) {
         const isSimilarToExisting = newTextNodesFound.some(node => similarities(textContent, node.text));
         if (!isSimilarToExisting && !addedTextNodes.has(textNode) && !sentTextNodes.has(textNode)) {
             newTextNodesFound.push({ text: originalText, textNode: textNode });
             addedTextNodes.add(textNode);
         }
     }
 
     processedNodes.add(textNode); // Add the processed node to the WeakSet
 
 }


  function traverseDOM(node, callback) {
    if (node.nodeType === Node.TEXT_NODE) {
      callback(node);
    } else if (node.nodeType === Node.ELEMENT_NODE) {
      for (let i = 0; i < node.childNodes.length; i++) {
        traverseDOM(node.childNodes[i], callback);
      }
    }
  }
  
  function scanNode(node) {
    if (isTextElement(node)) {
      traverseDOM(node, processTextNode);
    } else if (node.shadowRoot) {
      // If the node has a shadowRoot, scan its content recursively
      node.shadowRoot.childNodes.forEach(scanNode);
    } else {
      node.childNodes.forEach(scanNode);
    }
  }

  // Start scanning the DOM and replacing text
  scanNode(document.body);

// Traverse iframes
for (const frame of document.getElementsByTagName('iframe')) {
    try {
      scanNode(frame.contentDocument.body);
    } catch (error) {}
  }

}


  

let scriptStartTime = Date.now(); // Record the script start time
let waitingForServerResponse = false;
let retryCounter = 0;
const maxRetries = 40; // Maximum number of retry attempts
let lastAttemptTime = 0;
const retryInterval = 60 * 1000; // 1 minute in milliseconds
const initialDelay2 = 20 * 1000; // 20 seconds in milliseconds

// Assuming newTextNodesFound and sentTextNodes are defined elsewhere in your script
// const newTextNodesFound = [...];
// const sentTextNodes = new Set();
let sentTextContents = new Set(); // New set to track text content sent to the server

function sendNewTextNodesToServer(forceSend = false) {
  const currentTime = Date.now();
  const timeElapsedSinceStart = currentTime - scriptStartTime;
  const timeSinceLastAttempt = currentTime - lastAttemptTime;


  if (isGTranslated) { 
    seatext_logging("Google Translate is active. Skipping sending text nodes to server.");
    return; // Exit the function early if Google Translate is detected
  }

  // Check if 20 seconds have passed since script start or if it's a forced send
  if (!forceSend && timeElapsedSinceStart < initialDelay2) {
    // If less than 20 seconds, wait until 20 seconds have passed
    const waitTime = initialDelay2 - timeElapsedSinceStart;
    seatext_logging(`Waiting ${waitTime / 1000} more seconds before executing.`);
    setTimeout(() => sendNewTextNodesToServer(true), waitTime);
    return;
  }
  
  // Check for retry interval compliance and maximum retries
  if ((waitingForServerResponse || retryCounter >= maxRetries) || (!forceSend && timeSinceLastAttempt < retryInterval)) {
   /// seatext_logging("Waiting for server response, retry limit reached, or not enough time passed since last attempt. Attempt:", retryCounter);
    return;
  }

  lastAttemptTime = currentTime; // Update the last attempt time
  retryCounter++;
  
  // Filter out nodes whose text is known, similar to known translations, or already sent
  const keyword = "SEATEXTCODEINTEGRATION"; // Define the keyword to look for
  const nodesToSend = newTextNodesFound.filter(node => {
    const textContent = node.text.trim();
    // Check if text content has been sent, is similar to known translations, or contains the keyword
    if (sentTextContents.has(textContent) || textContent.includes(keyword)) {
      return false; // Text content already sent or contains the keyword
    }
    for (const knownText of knownTextSet) {
      if (similarities(textContent, knownText)) {
        return false; // Similar to known text, do not send
      }
    }
    return true; // Not sent, not similar to any known text, and does not contain the keyword, send it
  });

  if (nodesToSend.length > 0) {
    waitingForServerResponse = true;
    const textContents = nodesToSend.map(node => node.text.trim());
  
    // Analyze all text nodes on the page
    let analyzedNodes = analyzePageText();
    analyzedNodes = categorizeSizes(analyzedNodes);
  
    // Prepare analysis data
    const textAnalysis = textContents.map(text => analyzeTextNode(text, analyzedNodes));

   const serverId = localStorage.getItem('seatext_id');
   
   const data = {
     originalTextArray: textContents,
     url: getBaseUrl(window.location.href),
     language: getLanguageCode(window.location.href),
     cdpData: CDP_data,
     serverId: serverId,
     textAnalysis: textAnalysis // Add the analysis data as a separate field
   };

    seatext_logging('Sending varinttomake to server:', JSON.stringify(data));

    fetch(`https://api.seatext.com:443/varinttomake`, {
      method: 'POST',
      headers: { 'Content-Type': 'application/json' },
      body: JSON.stringify(data),
    })
    .then(response => {
      if  (data.success) {
        throw new Error(`Server response: ${response.statusText}`);
      }
      return response.json();
    })
    .then(data => {
      seatext_logging('Received response from server:', data);
      retryCounter = 5; // Reset retry counter on successful response
      textContents.forEach(text => sentTextContents.add(text));
    })
    .catch(error => {
      console.error('Error sending new text nodes to server:', error);
    })
    .finally(() => {
      waitingForServerResponse = false;
      // If the attempt was successful or max retries reached, don't retry
      if (retryCounter < maxRetries) {
        setTimeout(() => sendNewTextNodesToServer(true), retryInterval);
      }
    });
  } else {
    seatext_logging('No new text nodes to send.');
    if (retryCounter < maxRetries) {
      setTimeout(() => sendNewTextNodesToServer(true), retryInterval);
    }
  }
}



// Retry mechanism
const retryIntervalID = setInterval(() => {
  if (retryCounter < maxRetries && !waitingForServerResponse) {
    sendNewTextNodesToServer();
  } else if (retryCounter >= maxRetries) {
    clearInterval(retryIntervalID); // Stop retrying once the max retries have been reached
  }
}, retryInterval);



// Launch the walk algorithm every 500ms - reason is dynamic elements wich need to be redrawn as fast as possible.
const setIntervalID = setInterval(() => {
  if (translationsLoaded) {
      scanDOMAndReplaceText();
  } else {
     /// seatext_logging(' Waiting server reply');
  }
}, 1000);

setTimeout(() => {
  scanDOMAndReplaceText(); // Scan the DOM once this is needed in case if nothing loaded - ie totatly new page
  sendNewTextNodesToServer(); // Then send the collected data
}, 10000); // Set this to slightly less than 10 seconds



function classifyText(element) {
  return "   "
}



let checkCookie = false; // Variable to control the checking of cookies


////////////////////////////////////////////thiis is event tracking part and sening conversions to server
let activeTime = 0, pageActive = false, lastEventTime = Date.now(), CONVERSION_THRESHOLD = 45, THROTTLE_DELAY = 1000; let scrollCount = 0;
let dataSent = false;

function uuidv4() {
  return ([1e7]+-1e3+-4e3+-8e3+-1e11).replace(/[018]/g, c => (c ^ crypto.getRandomValues(new Uint8Array(1))[0] & 15 >> c / 4).toString(16));
}

const throttle2 = (func, delay) => {
  let lastFunc, lastRan;
  return function(...args) {
    if (!lastRan) {
      func(...args);
      lastRan = Date.now();
    } else {
      clearTimeout(lastFunc);
      lastFunc = setTimeout(() => {
        if ((Date.now() - lastRan) >= delay) {
          func(...args);
          lastRan = Date.now();
        }
      }, delay - (Date.now() - lastRan));
    }
  }
};

const isSalesEvent = element => {
  const ecommerceClasses = ["woocommerce", "shopify", "magento", "bigcommerce", "opencart", "drupal", "prestashop", "oscommerce", "joomla", "zencart"], 
  salesKeywords = ["add to cart", "buy now", "purchase", "checkout"], 
  elementText = element.innerText.toLowerCase(), 
  elementHref = element.href ? element.href.toLowerCase() : "";
  
  return ecommerceClasses.some(ecommerceClass => element.classList.contains(ecommerceClass)) || salesKeywords.some(keyword => elementText.includes(keyword) || elementHref.includes(keyword));
};

const sendEvent = () => {
  // Check if data has been sent or if the "seatext_conversion_cookie" is present
  seatext_logging('!!!Sending Conversion data to server');
  if (dataSent || (checkCookie && document.cookie.split('; ').find(row => row.startsWith('seatext_conversion_cookie')))) {
    seatext_logging('Data has already been sent or cookie is present and checkCookie is true.');
    return;
  }

    // *** Add this check here ***
    if (!translationsLoaded) {
      seatext_logging('Translations not loaded, skipping conversion data send.');
      return; 
    }
  const serverUrl = `https://api.seatext.com:443/event`;
  const languageCode = navigator.language.split('-')[0];
  const data = JSON.stringify({
    url: getBaseUrl(window.location.href),
    changedTextNodes: changedTextNodes.map(node => ({
      originalText: node.originalText, newText: node.newText
    })),
    language: languageCode
  });

  if (!navigator.sendBeacon(serverUrl, data)) {
    // Fallback for sendBeacon, if needed
    console.error("sendBeacon failed, attempting to use fetch as a fallback.");
    fetch(serverUrl, {
      method: 'POST',
      headers: { 'Content-Type': 'application/json' },
      body: data,
      keepalive: true // This option is important for fetch to work in page unload scenario
    }).catch(error => console.error("Failed to send event with fetch fallback:", error));
  }

  seatext_logging('Conversion data sent to server:', data);
  dataSent = true;
  document.cookie = "seatext_conversion_cookie=true; path=/; max-age=9986400"; 
};




const sendEventIfConversion = () => {
  if (activeTime >= CONVERSION_THRESHOLD) {
    activeTime = 0;
    sendEvent();
  } else if (eventData.sale || eventData.click || eventData.read80Percent) {
    eventData.sale = false;
    eventData.click = false;
    eventData.read80Percent = false;
    sendEvent();
  }
};

const eventData = {sessionId: uuidv4(), sale: false, click: false, read80Percent: false};

document.addEventListener("mousemove", throttle2(() => {
  ///seatext_logging("Mouse moved.");
  const now = Date.now();
  if (pageActive) {
    activeTime += (now - lastEventTime) / 1000;
  }
  pageActive = true;
  lastEventTime = now;
  sendEventIfConversion();
}, THROTTLE_DELAY));

document.addEventListener("scroll", throttle2(() => {
  //seatext_logging("Page scrolled.");
  const now = Date.now();
  if (pageActive) {
    activeTime += (now - lastEventTime) / 1000;
  }
  pageActive = true;
  lastEventTime = now;
  const totalHeight = document.documentElement.scrollHeight,
    scrollPosition = window.scrollY + window.innerHeight;
  if (scrollPosition / totalHeight >= 0.8) {
    eventData.read80Percent = true;
  }

   scrollCount++;// Increase the scroll count whenever a scroll event happens

  if (scrollCount >= 4000 && activeTime >= CONVERSION_THRESHOLD) {
    // When user has scrolled at least 10 times and the active time is above the conversion threshold, send event
    sendEventIfConversion();
  }
}, THROTTLE_DELAY));

document.addEventListener("click", event => {
  const target = event.target;
  if (target.tagName === "A" || target.tagName === "BUTTON") {
    if (isSalesEvent(target)) {
      eventData.sale = true;
    }
    eventData.click = true;
    sendEventIfConversion(); // Note: sendEventIfConversion needs to be adjusted to not await sendEvent
  }
});


isGTranslated = false;

function shouldExcludeTextNode(textNode) {
  ///return false;
  const textContent = textNode.textContent.trim();

  if (textContent.includes("Rate this translation") || 
  textContent.includes("Your feedback will be used to improve Google Translate")) {
seatext_logging('Google Translate detected, setting isTranslated to true.');
isGTranslated = true; // Set the flag to prevent further text sending
return true; // Exclude this text node from processing
}



    // New check using isNonTextContent function
    if (isNonTextContent(textContent)) {
     /// seatext_logging('Excluding text node because it matches non-text content patterns.');
      return true;
  }

  if (textContent.toLowerCase().includes("SEATEXTCODEINTEGRATION")) {
  ///  seatext_logging('Excluding text node because it contains "Seatextcodeintegration".');
    return true;
  }


    return false;
}

function isPatternDominant(pattern) {
  const match = currentTextContent.match(pattern);
  if (match && match[0]) {
    if ((match[0].length / currentTotalLength) >= 0.7) {
      return true;
    }
  }
  return false;
}



function isNonTextContent(text) {

  currentTextContent = text;
  currentTotalLength = text.length;


  const patterns = [
    // Strict HTML tag pattern
    /^<[a-z]+(?:\s+[a-z-]+(?:=(?:"[^"]*"|'[^']*'|\S+))?)*\s*>$/i,
    
    // Strict CSS patterns
    /^[a-z-]+\s*:\s*[^;]+;$/i, // CSS property
    /^@(?:keyframes|media|font-face|import|charset|namespace|supports|document)\b/i, // CSS at-rules
    /^#[a-z][\w-]*\s*\{[^}]*\}$/i, // CSS ID selector
    /^\.[a-z][\w-]*\s*\{[^}]*\}$/i, // CSS class selector
    /^[a-z][\w-]*\s*\{[^}]*\}$/i, // CSS element selector
    /^@media\s+[^{]+\{[^}]+\}$/i, // CSS media query
    
    // Strict JavaScript patterns
    /^function\s+[a-z_$][\w$]*\s*\([^)]*\)\s*\{/i, // Function declaration
    /^(?:var|let|const)\s+[a-z_$][\w$]*\s*=\s*function\s*\([^)]*\)\s*\{/i, // Function expression
    /^(?:var|let|const)\s+[a-z_$][\w$]*\s*=\s*\([^)]*\)\s*=>\s*[{(]/i, // Arrow function
    /^if\s*\([^)]+\)\s*\{/i, // If statement
    /^for\s*\([^)]+\)\s*\{/i, // For loop
    /^while\s*\([^)]+\)\s*\{/i, // While loop
    /^switch\s*\([^)]+\)\s*\{/i, // Switch statement
    /^try\s*\{|catch\s*\([^)]*\)\s*\{|finally\s*\{/i, // Try-catch-finally
    /^class\s+[A-Z][a-zA-Z0-9_$]*\s*\{/i, // Class declaration
    
    // WordPress specific patterns
    /^wp_[a-z_]+\(/i,
    /^do_action\(/i,
    /^apply_filters\(/i,
    
    // PHP-like patterns
    /^\$[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*$/,
    
    // SQL-like patterns
    /^SELECT\b.+\bFROM\b.+(?:\bWHERE\b|\bGROUP BY\b|\bORDER BY\b)/i,
    
    // File path patterns
    /^\/(?:wp-content|wp-includes|plugins)\/[^\/]+\/[^\/]+\.php$/i,
    
    // URL patterns
    /^https?:\/\/[a-z0-9-]+(\.[a-z0-9-]+)+([\/\?#][^\s]*)?$/i,


    // New pattern for URL addresses without http(s):// prefix
     /^(?!.*\s)(?:[a-z0-9-]+\.)+(?:com|org|net|edu|gov|mil|io|co|ai|app|dev|info|biz|uk|de|jp|fr|au|ca|ru|ch|it|nl|se|no|es|us|me|tv|cc|eu|xyz|tech|blog|online|store|site|shop|club|pro|live|cloud|work|design|life|world|news|today|space|guru|games|gg)(?:\/[^\s]*)?$/i
  ];

  

  for (let pattern of patterns) {
    if (pattern.test(text.trim())) {
      //seatext_logging(`Excluded non-text content: "${text}"`);
      ///seatext_logging(`Blocked by pattern: ${pattern.toString()}`);
      return true;
    }
  }


  // Check for URLs
  if (isPatternDominant(/^(http:\/\/|https:\/\/)\S+/)) {
   /// seatext_logging("Blocked content (URL):", text);
    return true;
  }

  // Check for Email addresses
  if (isPatternDominant(/\b[A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\.[A-Z|a-z]{2,}\b/)) {
   //// seatext_logging("Blocked content (Email address):", text);
    return true;
  }

  // Improved Check for US Postal Addresses
  if (isPatternDominant(/\b\d{1,5}\s+\w+(\s+\w+)*,\s+(AL|AK|AS|AZ|AR|CA|CO|CT|DE|DC|FM|FL|GA|GU|HI|ID|IL|IN|IA|KS|KY|LA|ME|MH|MD|MA|MI|MN|MS|MO|MT|NE|NV|NH|NJ|NM|NY|NC|ND|MP|OH|OK|OR|PW|PA|PR|RI|SC|SD|TN|TX|UT|VT|VI|VA|WA|WV|WI|WY)\s+\d{5}(-\d{4})?\b/)) {
   /// seatext_logging("Blocked content (US Postal Address):", text);
    return true;
  }

  // Check for American style time
  if (isPatternDominant(/\b\d{1,2}:\d{2}\s*(AM|PM)\b/i)) {
  ///  seatext_logging("Blocked content (American style time):", text);
    return true;
  }

  // Check for European style time
  if (isPatternDominant(/\b([01]?[0-9]|2[0-3]):[0-5][0-9]\b/)) {
  ///  seatext_logging("Blocked content (European style time):", text);
    return true;
  }

  // Check for addresses in major cities outside of the US
  if (isPatternDominant(/\b\d{1,4}\s+\w+(\s+\w+)*,\s+\d{4,5}\s+(Tokyo|Delhi|Mumbai|Shanghai|Sao Paulo|Beijing|Mexico City|Cairo|Dhaka|Osaka|Karachi|Buenos Aires|Chongqing|Istanbul|Kolkata|Manila|Lagos|Rio de Janeiro|Tianjin|Kinshasa|Guangzhou|Los Angeles|Moscow|Shenzhen|Lahore|Bangalore|Paris|Bogota|Jakarta|Chennai|Lima|Bangkok|Seoul|Nagoya|Hyderabad|London|Tehran|Chicago|Chengdu|Nanjing)\b/)) {
   /// seatext_logging("Blocked content (International city address):", text);
    return true;
  }

  // Check for Canadian Postal Addresses
  if (isPatternDominant(/\b\d{1,5}\s+[a-zA-Z]+(?:\s[a-zA-Z]+)*,\s+[A-Z]{2},\s+[A-Z]\d[A-Z]\s+\d[A-Z]\d\b/)) {
    ///seatext_logging("Blocked content (Canadian Postal Address):", text);
    return true;
  }

  // Check for UK Addresses
  if (isPatternDominant(/\b\d{1,4}\s+\w+(\s+\w+)*,\s+\w+,\s+[A-Z]{1,2}\d{1,2}\s+\d[A-Z]{2}\b/)) {
  //  seatext_logging("Blocked content (UK Address):", text);
    return true;
  }

  // Check if text consists only of numbers, spaces, and symbols
  if (isPatternDominant(/^[\d\s.,:;!?@#$%^&*()_+\-=[\]{}\\|'`~<>\/"]+$/)) {
   /// seatext_logging("Blocked content (Numbers, spaces, and symbols only):", text);
    return true;
  }

  // Check for Ethereum address patterns
  if (isPatternDominant(/^0x[a-fA-F0-9]{6,40}$|^0x[a-fA-F0-9]{1,6}...[a-fA-F0-9]{1,6}$/)) {
  ///  seatext_logging("Blocked content (Ethereum address):", text);
    return true;
  }

  if (isPatternDominant(/\b(GMT|UTC)[+\-]\d+\b/)) {
   // seatext_logging("Blocked content (Time zone):", text);
    return true;
  }

    
  // Check for monetary values
  if (isPatternDominant(/\b\d{1,10}(\.\d+)?[\s$€£]+(K|M|B)?\b/)) {
    ///seatext_logging("Blocked content (Monetary value):", text);
    return true;
  }

  // Extended check for various monetary values
  if (isPatternDominant(/\b\d{1,3}(,\d{3})*(\.\d+)?[\s$€£]?(K|M|B|Trillion)?\b/)) {
   /// seatext_logging("Blocked content (Extended monetary value):", text);
    return true;
  }

  // Check for decimal numbers potentially followed by subscript characters
  if (isPatternDominant(/\d+\.\d+[_\d]+/)) {
   /// seatext_logging("Blocked content (Decimal with subscript):", text);
    return true;
  }

  // Check for patterns like "...f226, ...35a7, ...7b2b"
  if (isPatternDominant(/\.\.\.[a-fA-F0-9]{4,}/)) {
   /// seatext_logging("Blocked content (Ellipsis followed by hex):", text);
    return true;
  }
  

  // Check for Time Zone Code + Number
  if (isPatternDominant(/(GMT|UTC)[+\-]\d+/)) {
    ///seatext_logging("Blocked content (Time zone code):", text);
    return true;
  }

  // Check for dynamically created alphanumeric patterns (e.g., hex codes)
  if (isPatternDominant(/[a-fA-F0-9]{6,}/)) {
   /// seatext_logging("Blocked content (Alphanumeric pattern):", text);
    return true;
  }
  
  return false;
}

//this generates links for google. v1
function generateLinks() {
  const currentUrl = new URL(window.location.href);
  seatext_logging('Generating links with translationLinks:', translationLinks);
  // Check if 'canonical' is in the language codes and create canonical link
  if (translationLinks.hasOwnProperty('canonical')) {
      const canonicalUrl = new URL(translationLinks['canonical']);
      const canonicalLink = document.createElement('link');
      canonicalLink.rel = 'canonical';
      canonicalLink.href = canonicalUrl.href;
      ////document.head.appendChild(canonicalLink); // Append the canonical link to the head
  } else {
      seatext_logging('Canonical URL not found in language codes.');
  }

  // Generate and append hreflang links for each language
  Object.keys(translationLinks).forEach(code => {
      if (code !== 'canonical') { // Skip 'canonical' as it's handled separately
          const langUrl = new URL(currentUrl);
          langUrl.searchParams.set('lang', code); // Append '?lang=code'
          const link = document.createElement('link');
          link.rel = 'alternate';
          link.hreflang = code;
          link.href = langUrl.href;
          document.head.appendChild(link); // Append the hreflang link to the head
      }
  });
}

///this helper funnction which check if speaicl tags like seatetdont sit higher on Domtree - so programers can use only one tag and everything down a tree will get the same tag to work 
function checkSpecialTags(node) {
  let currentNode = node;
  let result = {
    hasSeatextDont: false,
    hasSeatextOnly: false,
    hasSeatextTranslateOff: false
  };

  while (currentNode && currentNode !== document.body) {
    if (currentNode.hasAttribute("data-seatextdont")) {
      result.hasSeatextDont = true;
    }
    if (currentNode.hasAttribute("data-seatextonly")) {
      result.hasSeatextOnly = true;
    }
    if (currentNode.hasAttribute("data-seatexttranslateoff")) {
      result.hasSeatextTranslateOff = true;
    }
    currentNode = currentNode.parentElement;
  }

  return result;
}




function getLanguageCode() {
  const urlParams = new URLSearchParams(window.location.search);
  const langParam = urlParams.get('lang'); // Retrieve the 'lang' parameter from the URL

  // Fallback strategy: URL lang parameter -> navigator.language -> document language -> 'en' as a last resort
  let languageCode = langParam || navigator.language || document.documentElement.lang || 'en';

  // Ensure languageCode is a string to prevent errors when calling substring method
  languageCode = typeof languageCode === 'string' ? languageCode : 'en';

  // Safely get the first two characters of the language code
  ////languageCode = languageCode.substring(0, 2);

  seatext_logging("Simplified language code:", languageCode);

  return languageCode;
}
function loadAndUseTranslations(languageCode) {
    const translationsKey = `translations_${languageCode}`;
    seatext_logging("Attempting to load translations with key:", translationsKey);

    const storedTranslations = localStorage.getItem(translationsKey);
    if (storedTranslations) {
        try {
            const translationsObj = JSON.parse(storedTranslations);
            seatext_logging("Loaded translations from local storage for key:", translationsKey);
            seatext_logging(translationsObj); // Print the actual content loaded from local storage

            // Assuming translationsObj directly contains the text translations
            replacements = translationsObj;
            seatext_logging("Applied translations to replacements:", replacements);

            populateKnownTextSet(translationsObj); // Ensure this uses the correct structure
            scanDOMAndReplaceText(); // Apply loaded translations
        } catch (error) {
            console.error("Error parsing translations from local storage:", error);
        }
    } else {
        seatext_logging(`No translations found in local storage for key: ${translationsKey}`);
    }
}

async function fetchAndUpdateTranslations(encodedidclient, encodedUrl, encodedLanguage) {
  seatext_logging(`Fetching translations for ${encodedLanguage}...`);

// Set V to 1 if lang parameter is present, else use a random number between 1 and 2
let V = Math.floor(Math.random() * 2) + 1;
const urlParams = new URLSearchParams(window.location.search);
  const langParam2 = urlParams.get('lang');
  if (langParam2) {
    V = 1;
}
V = 1;
  

  // Get the current URL and check for the 'lang' parameter
 
  
  // If the 'lang' parameter is present, set V to 1
 
seatext_logging(`SEATEXT Using random value V: ${V}`);



///this is first attemps of seatext personalisation
  // Check for seatext parameter
  const seatextAIParam = urlParams.get('seatext');
  let apiUrl = `https://api.seatext.com:443/api.js?idclient=${encodedidclient}&url=${encodedUrl}&language=${encodedLanguage}&V=${V}`;

  // If seatext is present, update the API URL to use api.seatext.com
  if (seatextAIParam) {
    apiUrl = `https://api.seatext.com:443/api.js?idclient=${encodedidclient}&url=${encodedUrl}&language=${encodedLanguage}&V=${V}&seatext=${encodeURIComponent(seatextAIParam)}`;
    seatext_logging(`SEATEXT AI Personalisation active: ${seatextAIParam}`);
  }

  let response;

  try {
    response = await fetch(apiUrl);
    if (!response.ok) {
      throw new Error("Failed to fetch translations from Fastly");
    }
  } catch (error) {
    console.error("Fastly fetch failed, trying fallback:", error);
    try {
      // Update fallback URL to include seatext if present
      let fallbackUrl = `https://api.seatext.com:443/api.js?idclient=${encodedidclient}&url=${encodedUrl}&language=${encodedLanguage}&V=${V}`;
      if (seatextAIParam) {
        fallbackUrl += `&seatext=${encodeURIComponent(seatextAIParam)}`;
      }
      seatext_logging(`SEATEXT Request URL (unencoded): ${apiUrl}`);
      response = await fetch(fallbackUrl);
      if (!response.ok) {
        throw new Error("Failed to fetch translations from fallback");
      }
    } catch (fallbackError) {
      console.error("Both Fastly and fallback fetch failed:", fallbackError);
      return;
    }
  }



  const responseJson = await response.json();
  seatext_logging("Received translations from server:", responseJson);
  translationsLoaded = true;
  const languageCode = getLanguageCode();


  if (responseJson.blocked) {
    seatext_logging("URL is blocked. Creating exit banner...");
    createExitBanner();
  } else {
    seatext_logging("URL is not blocked.");
  }


  // Update HTML language attribute when translations are successfully loaded
  updateLanguageTag(languageCode); 
  seatext_logging('HTML language tag updated to:', languageCode);

  const translationsKey = `translations_${encodedLanguage}`; // Updated to use encodedLanguage for key
  seatext_logging(`Attempting to update translations under key: ${translationsKey}`);

  // Read existing translations from localStorage
  const existingTranslationsStr = localStorage.getItem(translationsKey);
  let existingTranslations = {};
  if (existingTranslationsStr) {
      try {
          existingTranslations = JSON.parse(existingTranslationsStr);
          seatext_logging("Existing translations loaded:", existingTranslations);
      } catch (error) {
          console.error("Error parsing existing translations:", error);
      }
  }

  // New translations from the server
  const newTranslations = responseJson.text;
  isTranslated = responseJson.isTranslated; // Store the translation flag
  seatext_logging("!!!!!isTranslated:", isTranslated);

  // Merge existing and new translations
  const mergedTranslations = {...existingTranslations, ...newTranslations};
  seatext_logging("Merged translations:", mergedTranslations);

  // Save merged translations back to localStorage
  localStorage.setItem(translationsKey, JSON.stringify(mergedTranslations));
  seatext_logging("Merged translations saved to local storage.");

  // Update global replacements object
  replacements = mergedTranslations;
  seatext_logging("Global replacements updated with merged translations.");

  // Populate known text set with new translations and apply
  populateKnownTextSet(replacements);

  scanDOMAndReplaceText();
}



function findTextNodeInDOM(text) {
  const treeWalker = document.createTreeWalker(
    document.body,
    NodeFilter.SHOW_TEXT,
    { acceptNode: node => node.textContent.trim().includes(text.trim()) ? NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_SKIP }
  );
  return treeWalker.nextNode();
}

function analyzePageText() {
  return Array.from(document.body.getElementsByTagName('*'))
    .filter(el => el.childNodes.length === 1 && el.childNodes[0].nodeType === Node.TEXT_NODE)
    .map(el => {
      const text = el.textContent.trim();
      if (text.length === 0) return null;

      const computedStyle = window.getComputedStyle(el);
      const fontSize = parseFloat(computedStyle.fontSize);

      return {
        text: text,
        fontSize: fontSize,
        element: el
      };
    })
    .filter(item => item !== null)
    .sort((a, b) => b.fontSize - a.fontSize);
}

function categorizeSizes(analyzedNodes) {
  const totalNodes = analyzedNodes.length;
  return analyzedNodes.map((item, index) => {
    const percentile = (index / totalNodes) * 100;
    let sizeCategory;
    if (percentile < 10) sizeCategory = "very large (likely a main title)";
    else if (percentile < 25) sizeCategory = "large (possibly a subtitle)";
    else if (percentile < 75) sizeCategory = "medium (regular text)";
    else if (percentile < 90) sizeCategory = "small";
    else sizeCategory = "very small (possibly fine print)";
    
    return { ...item, sizeCategory };
  });
}

function analyzeTextNode(text, analyzedNodes) {
  const matchingNode = analyzedNodes.find(node => node.text.includes(text));
  if (!matchingNode) return "Text not found in analyzed nodes";

  const computedStyle = window.getComputedStyle(matchingNode.element);

  let isClickable = false;
  let isMenu = false;
  let current = matchingNode.element;
  while (current) {
    if (current.tagName === 'A' || current.tagName === 'BUTTON' || 
        current.onclick || computedStyle.cursor === 'pointer') {
      isClickable = true;
    }
    if (current.tagName === 'NAV' || current.tagName === 'MENU' || 
        current.getAttribute('role') === 'navigation') {
      isMenu = true;
    }
    current = current.parentElement;
  }

  return `This text is ${matchingNode.sizeCategory}. ` +
         `It is ${computedStyle.textTransform === 'uppercase' ? 'all capitals' : 'not all capitals'}. ` +
         `It is ${isClickable ? 'clickable' : 'not clickable'}. ` +
         `It is ${isMenu ? 'part of a menu' : 'not part of a menu'}.`;
}


function isWithinForm(node) {
  let element = node.parentElement;
  
  while (element) {
    // Standard HTML form elements
    if (['INPUT', 'TEXTAREA'].includes(element.tagName)) {
      if (element.type !== 'button' && element.type !== 'submit' && element.type !== 'reset') {
        return true;
      }
    }
    
    // Check element className and attributes
    if (element.className && typeof element.className === 'string') {
      const classNames = element.className.split(' ');
      
      // Ant Design
      if (classNames.some(className => ['ant-input', 'ant-input-textarea'].some(prefix => className.startsWith(prefix)))) {
        return true;
      }
      
      // Material-UI
      if (classNames.some(className => ['MuiInputBase-input', 'MuiOutlinedInput-input', 'MuiInput-input'].some(prefix => className.startsWith(prefix)))) {
        return true;
      }
      
      // React Bootstrap
      if (classNames.includes('form-control') && (element.tagName === 'INPUT' || element.tagName === 'TEXTAREA')) {
        return true;
      }
      
      // Semantic UI React
      if (classNames.includes('ui') && classNames.includes('input') && (element.tagName === 'INPUT' || element.tagName === 'TEXTAREA')) {
        return true;
      }
      
      // Chakra UI
      if (classNames.some(className => ['chakra-input', 'chakra-textarea'].some(prefix => className.startsWith(prefix)))) {
        return true;
      }
      
      // Formik
      if (classNames.some(className => className.startsWith('formik-')) && (element.tagName === 'INPUT' || element.tagName === 'TEXTAREA')) {
        return true;
      }
      
      // React Final Form
      if (classNames.some(className => className.startsWith('final-form-')) && (element.tagName === 'INPUT' || element.tagName === 'TEXTAREA')) {
        return true;
      }
      
      // Elementor
      if (classNames.some(className => className.startsWith('elementor-field-textual'))) {
        return true;
      }
      
      // Wix
      if (classNames.some(className => ['wixui-text-input', 'wixui-text-box'].some(prefix => className.startsWith(prefix)))) {
        return true;
      }
      
      // Webflow
      if (classNames.includes('w-input') && (element.tagName === 'INPUT' || element.tagName === 'TEXTAREA')) {
        return true;
      }
    }
    
    // Check for specific attributes
    if (element.getAttribute('contenteditable') === 'true') {
      return true;
    }
    
    // React Hook Form
    if (element.dataset && 'rhfField' in element.dataset && (element.tagName === 'INPUT' || element.tagName === 'TEXTAREA')) {
      return true;
    }
    
    // Vuetify
    if (element.dataset && 'vModel' in element.dataset && (element.tagName === 'INPUT' || element.tagName === 'TEXTAREA')) {
      return true;
    }
    
    element = element.parentElement;
  }
  
  return false;
 }

 function cleanAndAdjustTranslation(originalText, translatedText) {
  

  // Other cleaning (if needed)
  translatedText = translatedText.replace(/"\]$/g, '');
  translatedText = translatedText.replace(/\] \]$/g, '');

  return translatedText;
}

///media part - has known bug need to improve

let isMediaSent = false; // Global flag





function scanDomAndReplaceMedia() {
  const mediaSelectors = 'img, video, iframe[src*="youtube.com"], [style*="background-image"]';
  const mediaElements = document.querySelectorAll(mediaSelectors);

  // Function to extract the filename from a URL
  function getFileNameFromUrl(url) {
    if (!url) return null; // Return null or an empty string if URL is falsy
    return url.split('/').pop().split('#')[0].split('?')[0];
}

  // Function to get media URL from an element
  function getMediaUrl(element) {
      switch (element.tagName) {
          case 'IMG':
              return element.src;
          case 'VIDEO':
          case 'IFRAME':
              return element.getAttribute('src');
          default:
              const backgroundImage = window.getComputedStyle(element).backgroundImage;
              if (backgroundImage !== 'none') {
                  const urlMatch = backgroundImage.match(/url\(["']?(.+?)["']?\)/);
                  return urlMatch ? urlMatch[1] : null;
              }
      }
      return null;
  }

  seatext_logging('Scanning media elements...');
  seatext_logging('Global replacements object at the start:', replacements);

  // Process each media element
  mediaElements.forEach(element => {
    const mediaUrl = getMediaUrl(element);

    const mediaFilename = getFileNameFromUrl(mediaUrl);
    if (!mediaFilename) {
        // Skip this element if no valid filename could be extracted
        return;
    }


      // Check if media replacements are available in the global replacements object
      if (replacements._media && typeof replacements._media === 'object') {
         // seatext_logging(`Checking media replacements for ${mediaFilename}`);
          //seatext_logging('Current media replacements object:', replacements._media);

          if (replacements._media.hasOwnProperty(mediaFilename)) {
              const replacement = replacements._media[mediaFilename];
              //seatext_logging(`Media replacement found for ${mediaFilename}: ${replacement}`);

              // Apply the replacement logic
              switch (element.tagName) {
                  case 'IMG':
                  case 'VIDEO':
                  case 'IFRAME':
                      element.src = replacement === 'default' ? element.src : replacement;
                      break;
                  default:
                      if (replacement !== 'default') {
                          element.style.backgroundImage = `url('${replacement}')`;
                      }
                      break;
              }
          } else {
             // seatext_logging(`No media replacement found for ${mediaFilename}`);
          }
      } else {
         // seatext_logging('No media replacements available or invalid replacements object');
      }
  });

  seatext_logging(`Final mediaNodesToTranslate contents:`, mediaNodesToTranslate);
}
// Define a helper function for fetch with a timeout
function fetchWithTimeout(url, options, timeout = 7000) {
  return new Promise((resolve, reject) => {
      const timer = setTimeout(() => {
          reject(new Error('Request timed out'));
      }, timeout);

      fetch(url, options).then(
          response => resolve(response),
          error => reject(error)
      ).finally(() => clearTimeout(timer));
  });
}

// Revised sendMediaUrlsToServer function
async function sendMediaUrlsToServer() {
  let errorOccurred = false;
  let errorDetails = null;

 ///seatext_logging('sendMediaUrlsToServer function started');

  // Check if media has not been sent and there are URLs to translate
  if (!isMediaSent && mediaNodesToTranslate.length > 0) {
    ////  seatext_logging('Preparing to send media URLs to server:', mediaNodesToTranslate);

      const serverUrl = 'https://api.seatext.com:443/mediatranslations';
      const payload = {
          url: window.location.href,
          language: navigator.language,
          mediaUrls: mediaNodesToTranslate.map(url => ({ OriginalUrl: url }))
      };

      try {
          seatext_logging('Sending request to server...');

          const response = await fetchWithTimeout(serverUrl, {
              method: 'POST',
              headers: { 'Content-Type': 'application/json' },
              body: JSON.stringify(payload)
          }, 10000); // 10 seconds timeout

          if (!response.ok) {
              throw new Error(`HTTP error: ${response.status}`);
          }

          isMediaSent = true;
        ///  seatext_logging('Sent media URLs to server for translation:', mediaNodesToTranslate);
          mediaNodesToTranslate.length = 0;
      } catch (error) {
          ///console.error('Error occurred during fetch operation:', error);
          errorOccurred = true;
          errorDetails = error;
      }
  } else {
      ///seatext_logging('No media URLs to send or media already sent');
  }

  if (errorOccurred) {
      //console.error('Failed to send media URLs to server for translation:', errorDetails);
      //console.error('Error details:', errorDetails.message);
  } else {
      ///seatext_logging('sendMediaUrlsToServer function completed without errors');
  }
}
  



const initialDelay = 10000; // 10 seconds delay
setTimeout(() => {
  seatext_logging('Retrying media processing after delay...');
 scanDomAndReplaceMedia();
 sendMediaUrlsToServer();
}, initialDelay);




























})(window, document); // Pass window and document to the IIFE